"use strict";
require("reflect-metadata");
function AsyncTest(description) {
    return function (target, propertyKey, descriptor) {
        // check if this has been registered as a test already
        var tests = Reflect.getMetadata("alsatian:tests", target);
        // if there are no tests registered yet then register it
        if (!tests) {
            tests = [{
                    key: propertyKey,
                    description: description,
                    isAsync: true
                }];
            Reflect.defineMetadata("alsatian:tests", tests, target);
        }
        else if (tests.filter(function (test) { return test.key === propertyKey; }).length === 0) {
            tests.push({
                key: propertyKey,
                description: description,
                isAsync: true
            });
            Reflect.defineMetadata("alsatian:tests", tests, target);
        }
        else {
            tests.filter(function (test) { return test.key === propertyKey; })[0].isAsync = true;
        }
    };
}
exports.AsyncTest = AsyncTest;
//# sourceMappingURL=async-test-decorator.js.map